/*
 * Created on 20-06-2004
 *
 */
package net.sf.hibernate.console;

import net.sf.hibernate.HibernateException;
import net.sf.hibernate.metadata.ClassMetadata;

import com.l2fprod.common.propertysheet.DefaultProperty;

/**
 * @author max
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class HibernateProperty extends DefaultProperty {

	protected final ClassMetadata cmd;
		
	
	public HibernateProperty(String name, ClassMetadata cmd) throws HibernateException {
		this(name,cmd, cmd.getPropertyType(name).getReturnedClass());		
	}
	
	public HibernateProperty(String name, ClassMetadata cmd, Class type) {
		this.cmd = cmd;
		init(name,type);		
	}

	private void init(String name, Class type) {
		setName(name);
		setDisplayName(name);				
		setType(type);
	}

	public void readFromObject(Object object) {
		try {
			setValue(cmd.getPropertyValue(object, getName()));
		} catch(HibernateException he) {
			throw new RuntimeException("readFromObject failed", he);
		}
	}
	
	public void writeToObject(Object object) {
		try {
			cmd.setPropertyValue(object, getName(), getValue());
		} catch(HibernateException he) {
			throw new RuntimeException("writeToObject failed", he);
		}
	}
		
}
