/*
 * Created on 12-08-2004
 *
 */
package net.sf.hibernate.console.views;

import java.awt.Container;

import javax.swing.JTree;
import javax.swing.ToolTipManager;
import javax.swing.tree.DefaultTreeModel;

import net.sf.hibernate.console.MappingsTreeCellRenderer;
import net.sf.hibernate.console.node.BaseNode;
import net.sf.hibernate.console.node.NodeFactory;
import net.sf.hibernate.Session;

/**
 * @author MAX
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class ObjectGraphView extends AbstractSessionView {

	private JTree objectGraph;

	public ObjectGraphView() {

		objectGraph = new JTree();
		ToolTipManager.sharedInstance().registerComponent(objectGraph);
		ToolTipManager.sharedInstance().setDismissDelay(Integer.MAX_VALUE);
		objectGraph.setCellRenderer(new MappingsTreeCellRenderer());

		objectGraph.setModel(new DefaultTreeModel(null));

	}
	
	public void objectUpdated(Session session, Object o) {
		if(session.contains(o)) {
    		BaseNode node = new NodeFactory(session.getSessionFactory()).createObjectNode(session, o);
		
    		objectGraph.setModel(new DefaultTreeModel(node));
    	} else {
    		objectGraph.setModel(new DefaultTreeModel(null));
    	}
	}
	
	public Container getContainer() {
		return objectGraph;
	}

}
