package net.sf.hibernate.console.docking;

import java.awt.Component;

import javax.swing.JComponent;

import net.eleritec.docking.DockableAdapter;
import net.eleritec.docking.DockingManager;

public class DockableImpl extends DockableAdapter {
	private ElegantPanel panel;
	private JComponent dragInitiator;
	
	public DockableImpl(String id, ElegantPanel dockable, JComponent dragInit) {
		super(id);
		if(dockable==null)
			new IllegalArgumentException(
			"Cannot create DockableImpl with a null DockablePanel.");
		if(dragInit==null)
			new IllegalArgumentException(
			"Cannot create DockableImpl with a null drag initiator.");
			
		panel = dockable;
		dragInitiator = dragInit;
		DockingManager.registerDockable(this);
	}

	public Component getDockable() {
		return panel;
	}

	public String getDockableDesc() {
		String desc = panel.getTitle();
		if(desc==null || desc.length()==0)
			return "null";
		return desc;
	}

	public Component getInitiator() {
		return dragInitiator;
	}

	public void setDockableDesc(String desc) {
		desc = desc==null? "": desc.trim();
		panel.setTitle(desc);
	}
}
